***********************************************************************
****	Marvin - ett deprimerande byggprojekt av
****     Stefan Johansson, Sven Mrtensson ss Pex Tufvesson
****
****	Version 1.0
****
**** Denna sourcekod r skriven fr att assembleras med "as11" till
**** PC-kompatibla datorer. Den ska anvndas med en 68HC11
**** som har EPROM mellan $d000-$ffff och RAM mellan $0000-$00ff.
**** En passande modell r t.ex. 68HC11E9, som med god marginal
**** klarar detta.
**** Skriv: "as11 Marvin.asm" - resultatet lagras i filen "Marvin.s19" som
**** kan laddas ner och programmeras i HC11:an.
**** 
**** Frutom detta br ven sjlva roboten finnas till hands, fr det
**** lr inte vara ngot strre nje att frska f igng detta program
**** utan att ha den ndvndiga hrdvaran, som kanske tar tre-fyra
**** veckor att bygga fr den hndige hemmaviraren.
****
**** Har du ngra frgor om koden eller annat, kontakta
**** Pex Tufvesson, http://mahoney.c64.org
**** s ska vi se vad som kan gras t saken.
****
**** De sidhnvisningar som finns lite varstans i koden refererar till
**** M68HC11 Reference Manual, den sta lilla rosa boken av Motorola 1990
**** som r ett mste om man ska kunna gra ngonting sjlv.
****
**** Ha det s roligt, det hade vi!
***********************************************************************

*** Konstanter:
LF	equ	$0a
CR	equ	$0d

***********************************************************************
*** EPROM-AREA	$d000-$ffff

	org	$d000

start:	bra	start2	* Hoppa ver kommentaren nedan.
	fcc	'Marvin r programmerad av Pex Tufvesson,'
	fcc	' Stefan Johansson och Sven Mrtensson 1995.'

start2:	sei
	ldx	#$1000		* accx r Bas fr alla portar
	bset	$26,x %10001000	* Set DDRA - alla PortA utgngar
	bclr	$26,x %

	ldaa	#%00000011	* PC0 och PC1 r utgngar
	staa	$07,x		* DDRC
	bclr	$03,x %00000011	* PortC
	jsr	AnalogInit
	jsr	DisplayInit
	jsr	InfoInit
	jsr	RadarInit
	jsr	MotorInit
	jsr	BounceInit

	jsr	BehaveInit
	jsr	IrInit
	jsr	IrqInit
	ldaa	#$0
	staa	<Debug
	cli			* Enable interrupts

* ------------------------------------------------------------------------------

ever:	bra	ever

*** IrqEver genereras varje 32.77 ms, och br syssla med uppdatering av
*** saker som ska g mjukt.
IrqEver:	ldx	#$1000
	bclr	$25,x %10111111	* TFLG2 - clear irq-request (sid 10-14)
	cli

	jsr	BounceRut		* Studsande boll i displayen
	jsr	IrEverRut		* IrKommandoTolk
	jsr	BehaveRut		* Vad gr Marvin?
	jsr	RadarRut
	jsr	RadarMotorRut
	jsr	MotorRut
	jsr	InfoRut
	jsr	AnalogRut
	jsr	DebugRut
	rti			* Return from interrupt

DebRts:	rts
DebugRut:
	ldaa	<Debug
	beq	DebRts

	ldaa	<Behavior		* Om Behavior=Denni -> ingen displayprint
	anda	#$0f
	cmpa	#$05
	beq	DebRts

	ldaa	#1		* Hr stoppar vi in alla vrden som
	jsr	DisplayToA		* kan vara intressanta fr just det
	ldaa	#'R		* som vi jobbar med just nu!
	jsr	DisplayPutChar
	ldd	<RadarWalls
	jsr	DisplayPutNumber
	ldaa	#' 
	jsr	DisplayPutChar

	ldaa	#'I
	jsr	DisplayPutChar
	ldab	$1000
	andb	#$02
	jsr	DisplayPutByte
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar

	ldaa	#64+1
	jsr	DisplayToA
	ldaa	#'B
	jsr	DisplayPutChar
	ldab	<Behavior
	jsr	DisplayPutByte
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar

	ldaa	#'P
	jsr	DisplayPutChar
	ldaa	#'I
	jsr	DisplayPutChar
	ldaa	#'D
	jsr	DisplayPutChar
	ldab	<PIDValue
	jsr	DisplayPutByte

	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar
	ldaa	#' 
	jsr	DisplayPutChar

	rts

* ----------------------------------------------------------------------------

Wait:	ldy	#$ffff		* Wait
WaitLop:
	dey
	bne	WaitLop
	rts

DisplayWelcome:
	fcb	$08
	fcc	'              '
	fcb	0
DisplayWelcome2:
	fcb	$09
	fcc	'              '
	fcb	0

*******************************************************************************
*** IrRut - kollar av fjrrkontrollen
*** IrKomLatch innehller koden fr den knapp som man trycker p
*** fr tillfllet.

IrInit:	ldx	#$1000
	bset	$22,x %00000001	* TMSK1 Enable Irq from IC3 - sid (10-16)
	bset	$21,x %00000010	* TCTL2 - Irq p fallande flank sid 10-17
	bclr	$21,x %00000001	*
	bset	$23,x %00000001	* TFLG - tm irqflagga

	clr	<IrBusy
	ldd	#$00
	std	<IrKommando
	std	<IrKomLatch
	clr	<IrValid
	rts

*** IrqEverRut - ser till att nolla ett inkommet Irkommando efter en viss tid, s
*** att IrKomLatch hller det som man gr JUST FR TILLFLLET med
*** fjrkontrollen. $0000 = inget kommando.

IrEverRut:
	ldd	<IrKomLatch	* r kommandot redan $0000 ?
	beq	IrRts
	ldaa	<IrValid		* r IrValid redan noll?
	beq	IrRts
	dec	<IrValid
	bne	IrRts
	ldd	#$0		* Nolla kommando
	std	<IrKomLatch
IrRts:	rts

*** IrIrq - Anropas vid varje fallande flank frn IrMottagaren.
IrIrq:	ldx	#$1000
	bset	$23,x %00000001	* TFLG - nolla irqflagga

	ldaa	<IrBusy		* r detta frsta signalen?
	bne	IrSecond
	ldd	$14,x	* T1C3 
	std	<IrLastTime	* Spara undan frsta timertiden
	inc	<IrBusy
	ldd	#$00	* Tm kommando
	std	<IrKommando
	rti

IrSecond:
	cmpa	#1		* r detta andra irq?
	bne	IrMiddle
	ldd	<IrLastTime
	coma
	comb
	addd	$14,x
	cpd	#$3c00	* r tiden fr lng? (r ca $394b - $39c0)
	bgt	IrNotValid
	cpd	#$3700	* r tiden fr kort?
	blt	IrNotValid
	inc	<IrBusy	* Tiden r OK, fortstt med IrMiddle vid nsta irq
	rti
IrNotValid:
	ldd	$14,x	* T1C3 - Tiden var fel, illegal signal, men kan vara
*			* inledningen till en korrekt signal.
	std	<IrLastTime	* Spara undan frsta timertiden
	rti

IrMiddle:
	ldd	<IrLastTime
	coma
	comb
	addd	$1014
	ldx	$1014
	stx	<IrLastTime
	cpd	#$5000	* r tiden ALLDELES fr lng? - Ja=Error...
	bgt	IrError
	cpd	#$0200	* r tiden ALLDELES fr kort? - Ja=Error...
	blt	IrError
	cpd	#$1400	* Tid ver xxx ms?
	rol	<IrKommando+1	* Rolla in carryflaggan i IrKommando
	rol	<IrKommando
	inc	<IrBusy
	ldaa	<IrBusy
	cmpa	#$17		* Har vi ftt in alla irq?
	bge	IrFinished
	rti

IrFinished:
	clr	<IrBusy
	ldd	<IrKommando
	cpd	<IrKomLatch
	beq	IrNoNew
	std	<IrKomLatchOnce
IrNoNew:
	std	<IrKomLatch
	ldaa	#$5	* IrKomLatch r giltig ($7-1)*32.77 ms efter mottagning
	staa	<IrValid
	rti

IrError:	clr	<IrBusy
	rti

*******************************************************************************
*** Behave - vilket uppfrande Marvin skall ha fr tillfllet. 950328
*** Fr att byta uppfrande, skriv vrde nedan till Behavior
*** s anropas XxxInit frst.
***
*** Behavior r fljande:
*** $00 - St still, 	no operation
*** $01 - Flj lampa 	LightRut
*** $02 - TestRutin	MotorTest
*** $03 - Fjrrkontrollsstyrning	FjarrRut
*** $04 - G mot mrker	DarkRut
*** $05 - Spela Denni	DenniRut
***
*** $a0 - $bf BumpRut fr respektive beteende ovan 

BehaveInit:
	clr	<Behavior
	rts

BehaveRut:
	jsr	BehaveCheckIr
	jsr	BehaveCheckBump
	ldaa	<Behavior
	bmi	BehaveNoInit
	oraa	#$80
	staa	<Behavior

	cmpa	#$80
	bne	NoStopInit
	jmp	StopInit
NoStopInit:
	cmpa	#$81
	bne	NoLightInit
	jmp	LightInit
NoLightInit:
	cmpa	#$82
	bne	NoMTestInit
	jmp	MTestInit
NoMTestInit:
	cmpa	#$83
	bne	NoFjarrInit
	jmp	FjarrInit
NoFjarrInit:
	cmpa	#$84
	bne	NoDarkInit
	jmp	DarkInit
NoDarkInit:
	cmpa	#$85
	bne	NoDenniInit
	jmp	DenniInit
NoDenniInit:
RRts:	rts

BehaveNoInit:
	cmpa	#$80
	beq	RRts
	cmpa	#$81
	bne	NoLightRut
	jmp	LightRut
NoLightRut:
	cmpa	#$82
	bne	NoMTestRut
	jmp	MTestRut
NoMTestRut:
	cmpa	#$83
	bne	NoFjarrRut
	jmp	FjarrRut
NoFjarrRut:
	cmpa	#$84
	bne	NoDarkRut
	jmp	DarkRut
NoDarkRut:
	cmpa	#$85
	bne	NoDenniRut
	jmp	DenniRut
NoDenniRut:
	jmp	BumpRut		* Inget "giltigt" behavior - BUMP-rut!

*** BehaveCheckIr - Kollar om vi vill byta behavior mha fjrrkontrollen
BehaveCheckIr:
	ldy	<IrKomLatchOnce
	cpy	#$ed02		* REC - knappen
	bne	BehNoDebug
	ldaa	<Debug		* Toggla debug ON/OFF
	eora	#$01
	staa	<Debug
	clr	<IrKomLatchOnce
	rts
BehNoDebug:
	cpy	#$d904		* -/-- knappen
	bne	BehNoRadarOnOff
	clr	<IrKomLatchOnce
	jmp	RadarToggleOnOff
BehNoRadarOnOff:

	ldy	<IrKomLatch
	ldx	#BehChangeList
	clra
BehLop:
	cpy	$00,x
	beq	BehFound
	inx
	inx
	inca
	cpx	#BehChangeListEnd
	bne	BehLop
	rts

BehFound:
	ldab	<Behavior
	andb	#$7f
	cba
	beq	BehRts	* Samma behavior som innan - inget byte
	cmpb	#$05
	beq	BehExitDenni
	staa	<Behavior	* Byt till nytt Behavior
BehRts:	rts

BehExitDenni:
	staa	<Behavior	* ExitDenni - terstll skrmen till rtt lge
	jmp	DenniExit

BehChangeList:
	fdb	$f900	* STOP - p knapp VTR
	fdb	$f501	* LightRut - p knapp 1
	fdb	$7511	* MTestRut - p knapp 2
	fdb	$b509	* FjarrRut - p knapp 3
	fdb	$3519	* DarkRut - p knapp 4
	fdb	$d505	* DenniRut - p knapp 5
*	fdb	$5515	* - p knapp 6
*	fdb	$9500	* - p knapp 7
*	fdb	$151d	* - p knapp 8
*	fdb	$e503	* - p knapp 9
BehChangeListEnd:

*******************************************************************************
*** Stop - Stannar motorerna  snt.
StopInit:
	ldd	#$7fff
	std	<MotorAcc
	ldd	#$8000
	std	<Motor1CurrSpeed	* VRLSTOPP - skit i acceleration.
	std	<Motor1Speed
	std	<Motor2CurrSpeed
	std	<Motor2Speed
	rts

*******************************************************************************
*** InfoRut - visar text om byggandet p displayen.

InfoInit:	ldd	#InfoText
	std	<InfoPoi
	clr	<InfoCou
	jsr	InfoDrawAA
InRts:	rts

InfoDrawAA:
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldab	#%01010000	* Stt GrafikPekare $10
	stab	$04,x		* PortB
	jsr	DisplayWait

	ldab	#$10
	ldy	#InfoAA

InfoAlo:	ldaa	$00,y
	iny
	bset	$08,x %00100000	* PD5 - RS
	staa	$04,x		* PortB

	pshy
	ldy	#$12
InfoWa:	dey
	bne	InfoWa
	puly

	decb
	bne	InfoAlo
	rts

InfoRut:	ldaa	<Debug
	bne	InRts
	ldaa	<Behavior
	anda	#$1f
	cmpa	#$05		* Spela Denni - ingen DisplayInfo
	beq	InRts

	ldaa	#15
	jsr	DisplayToA
	ldaa	#$02		* RadarTecknet
	tst	<RadarOn
	bne	YesRadar
	ldaa	#$08		* BollTecken
YesRadar:
	jsr	DisplayPutChar
	ldaa	#15+64
	jsr	DisplayToA
	ldaa	#32		* Space-Tecken
	tst	<RadarOn
	bne	Yes2Radar
	ldaa	#$09
Yes2Radar:
	jsr	DisplayPutChar

	ldaa	<InfoCou
	bmi	<InfoSRut
	inc	<InfoCou
	cmpa	#$38
	blt	InRts
	clr	<InfoCou

	ldaa	#$01
	jsr	DisplayToA
	ldx	<InfoPoi
	ldy	#$0e
InfoLop:	ldaa	$00,x
	jsr	DisplayPutChar
	inx
	dey
	bne	InfoLop

	ldaa	#$41
	jsr	DisplayToA
	ldy	#$0e
InfoL2p:	ldaa	$00,x
	jsr	DisplayPutChar
	inx
	dey
	bne	InfoL2p

	ldaa	$0,x
	bne	InfoNoWrap
	ldaa	#$80
	staa	<InfoCou
	inx
InfoNoWrap:
	stx	<InfoPoi
In2Rts:	rts

InfoSRut:
	inc	<InfoCou
	cmpa	#$85
	bne	In2Rts
	ldaa	#$80
	staa	<InfoCou
	ldx	<InfoPoi
	inx
	stx	<InfoPoi
	ldaa	#$41
	jsr	DisplayToA
	ldy	#$0e
InfoL3p:	ldaa	$00,x
	jsr	DisplayPutChar
	inx
	dey
	bne	InfoL3p

	ldaa	$00,x
	bne	InfoNoSWrap
	ldab	#$60
	stab	<InfoCou	* Byta till tvradersvisning
	inx
	stx	<InfoPoi
	rts
InfoNoSWrap:
	cmpa	#$ff
	beq	InfoWrap
	rts

InfoWrap:
	ldab	#$60
	stab	<InfoCou	* Starta om infoslingan
	ldx	#InfoText
	stx	<InfoPoi
	rts

*	 = 
*	 = 

InfoAA:
	fcb	%00000
	fcb	%00010
	fcb	%01001
	fcb	%00101
	fcb	%10101
	fcb	%00101
	fcb	%01001
	fcb	%00010

	fcb	%00100
	fcb	%00000
	fcb	%01110
	fcb	%00001
	fcb	%01111
	fcb	%10001
	fcb	%01111
	fcb	%00000

*	0123456789abcdef
InfoText:
	fcc	' Hejsan dr   '
	fcc	'        uppe! '
	fcc	'   Hur m'
	fcb	$03
	fcc	'r    '
	fcc	'    du idag?  '
	fcc	'Jag r Marvin!'
	fcc	'              '
	fcc	'Jag r Marvin!'
	fcc	'Jag r din vn'
	fcc	'              '
	fcc	'... om jag f'
	fcb	$03
	fcc	'r'
	fcc	'  F'
	fcb	$03
	fcc	'r jag det?'
	fcc	'              '
	fcc	'S'
	fcb	$03
	fcc	' hr gr du:'
	fcc	'              '
	fcb	0

	fcc	'              Du har, frhoppningsvis, '
	fcc	'en fjrrkontroll i handen. Har du inte det '
	fcc	'r du OBEHRIG och d'
	fcb	$03
	fcc	' tnker jag inte '
	fcc	'leka med dig.'
	fcc	'                   '
	fcb	0

	fcc	'Jag vill tacka'
	fcc	' dessa genier:'
	fcb	$08
	fcc	'  Stefan    '
	fcb	$08,$09
	fcc	' Johansson  '
	fcb	$09
	fcb	$08
	fcc	'    Sven    '
	fcb	$08,$09
	fcc	' M'
	fcb	$03
	fcc	'rtensson '
	fcb	$09
	fcb	$08
	fcc	'    Pex     '
	fcb	$08,$09
	fcc	' Tufvesson  '
	fcb	$09
	fcc	'fr att de har'
	fcc	' varit snlla '
	fcc	'mot mig och d'
	fcb	$03
	fcc	'givit mig den '
	fcc	'*** Krlek ***'
	fcc	'**************'
	fcc	'en ensam robot'
	fcc	'alltid behver'
	fcc	'Har du gett en'
	fcc	'robot en kram?'
	fcc	'Jag tycker om '
	fcc	' att kramas...'
	fcc	'Jag r Marvin!'
	fcc	'              '
	fcb	0

	fcc	'              Tryck p'
	fcb	$03
	fcc	' 5 fr att spela spel!'
	fcc	'                    '
	fcb	0

	fcc	'Jag gillar    '
	fcc	'        glass!'
	fcc	'Jag gillar    '
	fcc	'        glass!'
	fcb	0

	fcc	'        glass!'
	fcc	'                    '
	fcb	0

	fcc	'Fr att styra:'
	fcc	'              '
	fcb	0

	fcc	'              Tryck p'
	fcb	$03
	fcc	' 3! D'
	fcb	$03
	fcc	' r '
	fcc	'Play=vnster - FF=hger - Pause=fram'
	fcb	$03
	fcc	't - Rew=bak'
	fcb	$03
	fcc	't '
	fcc	'- Stop=stop'
	fcc	'                    '
	fcb	0

	fcc	'Ska ljus gr '
	fcc	'    jag nr du'
	fcc	'Ska ljus gr '
	fcc	'    jag nr du'
	fcb	0

	fcc	'    jag nr du trycker p'
	fcb	$03
	fcc	' 1!'
	fcc	'                    '
	fcb	0

	fcc	'Jag r Marvin!'
	fcc	'              '
	fcc	' Fantasi r   '
	fcc	'      GRATIS! '
	fcc	'Jag fantiserar'
	fcc	'om sta Marvia'
	fcc	'Jag kan gra  '
	fcc	'     ingenting'
	fcc	'Jag kan gra  '
	fcc	'     ingenting'
	fcb	0

	fcc	'     ingenting om du trycker p VTR. D'
	fcb	$03
	fcc	' lgger jag av.'
	fcc	'                    '
	fcb	0

	fcc	' Jag kan mer! '
	fcc	'              '
	fcb	0

	fcc	'              Tryck p'
	fcb	$03
	fcc	' 4 s'
	fcb	$03
	fcc	' sker jag mrker!'
	fcc	'                    '
	fcb	0

	fcc	'Ganska duktigt'
	fcc	'          va? '
	fcc	'              '
	fcc	'              '
	fcc	'              '
	fcc	'Mina pappor r'
	fcc	'Mina pappor r'
	fcc	' tre trevliga '
	fcc	' tre trevliga '
	fcc	'  teknologer  '
	fcc	'  teknologer  '
	fcc	'och jag gillar'
	fcc	'och jag gillar'
	fcc	'  dem skarpt! '
	fcb	8,8,8,8,8,8,8,8,8,8,8,8,8,8
	fcb	9,9,9,9,9,9,9,9,9,9,9,9,9,9
	fcb	$08
	fcc	'    Pex     '
	fcb	$08,$09
	fcc	' Tufvesson  '
	fcb	$09
	fcb	8,8,8,8,8,8,8,8,8,8,8,8,8,8
	fcb	9,9,9,9,9,9,9,9,9,9,9,9,9,9
	fcb	$08
	fcc	'    Sven    '
	fcb	$08,$09
	fcc	' M'
	fcb	$03
	fcc	'rtensson '
	fcb	$09
	fcb	8,8,8,8,8,8,8,8,8,8,8,8,8,8
	fcb	9,9,9,9,9,9,9,9,9,9,9,9,9,9
	fcb	$08
	fcc	'  Stefan    '
	fcb	$08,$09
	fcc	' Johansson  '
	fcb	$09
	fcb	8,8,8,8,8,8,8,8,8,8,8,8,8,8
	fcb	9,9,9,9,9,9,9,9,9,9,9,9,9,9
	fcc	'   Riktiga    '
	fcc	'toppengrabbar!'
	fcc	'   Riktiga    '
	fcc	'toppengrabbar!'
	fcc	'              '
	fcc	'              '
	fcb	0

	fcc	'              Om idag var en fisk skulle jag slnga '
	fcc	'tillbaka den i sjn.'
	fcc	'                    '
	fcb	$ff

*******************************************************************************
*** RadarRut - anvnder IR-sndarna p framkanten fr att detektera
*** vggar INNAN Marvin springer in i dem

RadarToggleOnOff:
	tst	<RadarOn
	bne	RadarExit

RadarInit:
	clr	<RadarCou
	clr	<RadarWalls
	ldx	#$1000
	ldaa	#%00000011	* PC0 och PC1 r utgngar
	staa	$07,x		* DDRC
	bclr	$03,x %00000011	* PortC
	ldd	#$2000
	std	<MotorAcc
	ldaa	#$1
	staa	<RadarOn
	rts

RadarExit:
	ldx	#$1000
	bclr	$03,x %00000011	* Slck dioderna
	clr	<RadarWalls	* Inga vggar
	clr	<RadarOn
RadaRts:
	rts

RadarNot:
	ldx	#$1000
	bclr	$03,x %00000011	* Slck dioderna
	rts

RadarRut:
	tst	<RadarOn
	beq	RadarNot
	ldaa	<Behavior
	anda	#$7f
	beq	RadarNot		* St still - ingen radar
	cmpa	#$02		* MotorTest - ingen radar
	beq	RadarNot
	cmpa	#$05		* Denni - ingen radar
	beq	RadarNot

	inc	<RadarCou
	ldaa	<RadarCou
	cmpa	#1
	beq	RadarFas1
	cmpa	#2
	beq	RadarFas2
	cmpa	#3
	beq	RadarFas3
	cmpa	#4
	beq	RadarFas4
	cmpa	#5
	beq	RadarFas5

	cmpa	#8
	bne	RadRts
	clr	<RadarCou
RadRts:	rts

* PC0=hger

*** RadarFaser:
*** 1. Tnd hger.
*** 2. Kolla om hger. Slck hger.
*** 3. Kolla s att slckt. Tnd vnster.
*** 4. Kolla om vnster. Slck vnster.
*** 5. Kolla s att slckt.
*** Drefter vnta tills vi vill kolla igen.

RadarFas1:
	ldx	#$1000
	bset	$03,x %00000001	* PortC
	rts

RadarFas2:
	ldx	#$1000
	ldaa	#$00
	brset	$00,x %00000010 RadarIsOff
	ldaa	#$01
RadarIsOff:
	staa	<RadarSlask
	bclr	$03,x %00000011
	rts

RadarFas3:
	ldx	#$1000
	ldaa	<RadarWalls
	brclr	$00,x %00000010 RadarIsError
	anda	#$fe
	tst	<RadarSlask
	beq	RadIngenHWall
	oraa	#$01
RadIngenHWall:
	staa	<RadarWalls
	bset	$03,x %00000010	* PortC - tnd vnster
	rts
RadarIsError:
	bset	$03,x %00000010	* PortC - tnd vnster
	rts

RadarFas4:
	ldx	#$1000
	ldaa	#$00
	brset	$00,x %00000010 RadarIsOff4
	ldaa	#$01
RadarIsOff4:
	staa	<RadarSlask
	bclr	$03,x %00000011
	rts

RadarFas5:
	ldx	#$1000
	ldaa	<RadarWalls
	brclr	$00,x %00000010 RadarIsError5
	anda	#%11111101
	tst	<RadarSlask
	beq	RadIngenVWall
	oraa	#%00000010
RadIngenVWall:
	staa	<RadarWalls
	rts
RadarIsError5:
RadiRts:	rts

RadarMotorRut:
	tst	<RadarOn	* r Radarn p?
	beq	RadiRts
	ldaa	<Behavior
	anda	#$7f
	cmpa	#$01	* Kolla radar om g mot ljus
	beq	DoRadar
	cmpa	#$03	* Kolla radar om fjrrkontrollstyrning
	beq	DoRadar
	cmpa	#$04	* Kolla radar om g mot mrker
	beq	DoRadar
	rts		* Annars gr ingenting
DoRadar:
	ldaa	<RadarWalls
	cmpa	#00
	bne	RadarAnyWall
	rts		* Kr som vanligt - ingen ndring!
RadarAnyWall:
	cmpa	#$01
	bne	RadarNoLeft
	clr	<RadarLast
	ldy	#$0000
	ldx	#$8000
	bra	RadarCont
RadarNoLeft:
	cmpa	#$02
	bne	RadarFullTurn
	ldaa	#$1
	staa	<RadarLast
	ldx	#$0000
	ldy	#$8000
	bra	RadarCont
RadarFullTurn:
	tst	<RadarLast
	beq	RadarFullTLeft
	ldy	#$ffff
	ldx	#$0000
	bra	RadarCont
RadarFullTLeft:
	ldy	#$0000
	ldx	#$ffff
RadarCont:
	sty	<Motor1Speed
	stx	<Motor2Speed
	rts

*******************************************************************************
*** FjarrRut - Styr Marvin med fjrrkontrollen.
*** Pause = acceleration
*** Rew = retardation
*** Stop = stopp
*** Play = vnster
*** FF = hger
*** Anropas av Behavior om $03

FjarrAcc equ $e00	* Hur snabbt Marvin accar med fjrrkontrollen
FjarrTurn equ $4000	* Hur snabbt Marvin svnger med Play/FF

FjarrInit:	ldd	#$e00
	std	<MotorAcc
	ldd	#$8000
	std	<Motor1Speed
	std	<Motor2Speed
	ldd	#$8000
	std	<FjarrSpeed
	rts

FjarrRut:
	ldd	<IrKomLatch
	cpd	#$9d0c
	bne	FjarrNoAcc
	ldd	<FjarrSpeed
	subd	#FjarrAcc
	bcc	FjarrNoLimit
	ldd	#$0000
FjarrNoLimit:
	std	<FjarrSpeed
	ldd	#$0000
	std	<IrKomLatch
	bra	FjarrCont
FjarrNoAcc:
	cpd	#$bd08
	bne	FjarrLeftRight
	ldd	<FjarrSpeed
	addd	#FjarrAcc
	bcc	FjarrNoLimit2
	ldd	#$ffff
FjarrNoLimit2:
	std	<FjarrSpeed
	ldd	#$0000
	std	<IrKomLatch
FjarrCont:
	ldd	<FjarrSpeed
	std	<Motor1Speed
	std	<Motor2Speed
	rts

FjarrLeftRight:
	cpd	#$ad0a
	bne	FjarrNoLeft
	ldd	<FjarrSpeed
	subd	#FjarrTurn
	bcc	FjarrNoLimit3
	ldd	#$0
	std	<Motor1Speed
	ldd	#FjarrTurn*2
	std	<Motor2Speed
	rts
FjarrNoLimit3:
	std	<Motor1Speed
	ldd	<FjarrSpeed
	addd	#FjarrTurn
	bcc	FjarrNoLimit4
	ldd	#$ffff
	std	<Motor2Speed
	ldd	#-2*FjarrTurn
	std	<Motor1Speed
	rts
FjarrNoLimit4:
	std	<Motor2Speed
	rts

FjarrNoLeft:
	cpd	#$3d18
	bne	FjarrNoRight	* Inte hger heller, d kr vi rakt fram...

	ldd	<FjarrSpeed
	subd	#FjarrTurn
	bcc	FjarrNoLimit5
	ldd	#$0
	std	<Motor2Speed
	ldd	#FjarrTurn*2
	std	<Motor1Speed
	rts
FjarrNoLimit5:
	std	<Motor2Speed
	ldd	<FjarrSpeed
	addd	#FjarrTurn
	bcc	FjarrNoLimit6
	ldd	#$ffff
	std	<Motor1Speed
	ldd	#-2*FjarrTurn
	std	<Motor2Speed
	rts
FjarrNoLimit6:
	std	<Motor1Speed
	rts

FjarrNoRight:
	cpd	#$fd00	* Ska vi STOP?
	bne	FjarrCont
	ldd	#$8000
	std	<FjarrSpeed
	std	<Motor1Speed
	std	<Motor2Speed
	rts

*******************************************************************************
*** BumpRut - Marvin har krt p ngonting, och ska backa fr att
*** undvika faran mot lem och lst. Stts automatiskt om ngon av
*** bumprarna aktiveras.
BehaveCheckBump:
	ldaa	<Behavior
	cmpa	#$a0
	bpl	BRts		* Vi r redan i BumpMode
	ldx	#$1000
	brset	$0a,x %10000000 BumpRightInit	* PE7 - hgerbumper
	brset	$0a,x %01000000 BumpLeftInit	* PE6 - vnsterbumper
BRts:	rts

BumpLeftInit:
	ldx	#BumpLeftTab
	bra	BumpInitCont
BumpRightInit:
	ldx	#BumpRightTab
BumpInitCont:
	stx	<BumpCou
	ldd	#$8000
	std	<Motor1CurrSpeed	* VRLSTOPP - skit i acceleration.
	std	<Motor1Speed
	std	<Motor2CurrSpeed
	std	<Motor2Speed
	ldx	#$1000
	ldd	#$8001		* Stt OutputComp.2,3 till #$8001=vila
	std	$18,x		* TOC2
	std	$1a,x		* TOC3

	ldaa	#$1
	staa	<BumpWaitCou
	ldd	#$c000
	std	<MotorAcc
	ldaa	<Behavior		* Spara undan gamla beteendet
	oraa	#$20
	staa	<Behavior
	rts

BumpRut:
	dec	<BumpWaitCou
	bne	BumpRts

	ldx	<BumpCou
	ldaa	$0,x
	beq	BumpFinished
	staa	<BumpWaitCou
	ldd	$1,x
	std	<Motor1Speed
	ldd	$3,x
	std	<Motor2Speed
	inx
	inx
	inx
	inx
	inx
	stx	<BumpCou
BumpRts:
	ldaa	<Behavior
	anda	#$1f
	cmpa	#$05
	bne	NoDenniBRut
	jmp	DenniRut
NoDenniBRut:
	rts

BumpFinished:
	ldaa	<Behavior
	anda	#$1f
	cmpa	#$03		* Om fjrrstyrning - ingen init
	beq	FjarrDontInit	* dvs Marvin ska fortstta med samma hastighet
	cmpa	#$05		* Ingen init med Denni heller...
	bne	BumpNoDenni
FjarrDontInit:
	oraa	#$80
BumpNoDenni:
	staa	<Behavior
	ldd	#$8000
	std	<Motor1CurrSpeed	* VRLSTOPP - skit i acceleration.
	std	<Motor1Speed
	std	<Motor2CurrSpeed
	std	<Motor2Speed
	rts

BumpRightTab:
	fcb	37
	fdb	$ff00,$ff00
	fcb	$40
	fdb	$6000,$ff00
	fcb	$00	* Fdi

BumpLeftTab:
	fcb	37
	fdb	$ff00,$ff00
	fcb	$40
	fdb	$ff00,$6000
	fcb	$00	* Fdi

*******************************************************************************
*** LightRut - Marvin kr mot ljusaste punkten i rummet.
*** Anropas av Behavior om $01
LightThreshold equ $38	* grns fr lika ljus (svng och kr rakt fram) och skillnad i ljus
*			* (svng p stllet)

LightInit:	ldd	#$800
	std	<MotorAcc
	rts

LightRut:
	ldaa	<LdrLeft
	ldab	<LdrRight
	sba
	bcc	LightRight
	coma
	cmpa	#LightThreshold	* Kolla om stor ljusskillnad
	ble	LightForwLeft
	ldd	#$0000		* Bara vrid Marvin mot ljuset
	std	<Motor1Speed
	ldd	#$ffff
	std	<Motor2Speed
	rts
LightForwLeft:
	ldd	#$0000
	std	<Motor1Speed
	ldd	#$5000
	std	<Motor2Speed
	rts
LightRight:
	cmpa	#LightThreshold	* Kolla om stor ljusskillnad
	ble	LightForwRight
	ldd	#$0000
	std	<Motor2Speed
	ldd	#$ffff
	std	<Motor1Speed
	rts
LightForwRight:
	ldd	#$0000
	std	<Motor2Speed
	ldd	#$5000
	std	<Motor1Speed
	rts

*******************************************************************************
*** DarkRut - Marvin kr mot mrkaste punkten i rummet.
*** Anropas av Behavior om $04

DarkInit:	ldd	#$a00
	std	<MotorAcc
	rts

DarkRut:
	ldaa	<LdrRight
	ldab	<LdrLeft
	sba
	bcc	DarkRight
	coma
	cmpa	#LightThreshold	* Kolla om stor ljusskillnad
	ble	DarkForwLeft
	ldd	#$0000		* Bara vrid Marvin mot mrker
	std	<Motor1Speed
	ldd	#$ffff
	std	<Motor2Speed
	rts
DarkForwLeft:
	ldd	#$0000
	std	<Motor1Speed
	ldd	#$5000
	std	<Motor2Speed
	rts
DarkRight:
	cmpa	#LightThreshold	* Kolla om stor ljusskillnad
	ble	DarkForwRight
	ldd	#$0000
	std	<Motor2Speed
	ldd	#$ffff
	std	<Motor1Speed
	rts
DarkForwRight:
	ldd	#$0000
	std	<Motor2Speed
	ldd	#$5000
	std	<Motor1Speed
	rts

*******************************************************************************
*** AnalogRut - scannar av PortE  sparar vrdena. 950328

AnalogInit:
	clr	<AnalogCou
	rts

AnalogRut:
	inc	<AnalogCou
	ldaa	<AnalogCou
	cmpa	#$5
	beq	AnalogStart
	cmpa	#$6
	beq	AnalogRead
	rts

AnalogStart:
	ldx	#$1000
	bset	$39,x %10000000	% Option - stt p A/D system
	bset	$30,x %00010000	% Adctl - starta A/D conv.
	rts

AnalogRead:
* AnalogWait:			
*	brclr	$30,x %10000000 AnalogWait   % vnta tills frdig...
	ldaa	$31,x		% PE1 analogvrde
	staa	<LdrLeft
	ldaa	$32,x		% PE2 analogvrde
	staa	<LdrRight
	ldaa	$33,x
	staa	<PIDValue
	clr	<AnalogCou
	rts

*******************************************************************************
*** MotorTest - Leker med motorerna. 950327

MTestInit:
	ldx	#MTestTab
	stx	<MTestCou1
	ldx	#MTestTab2
	stx	<MTestCou2
	ldd	#$500
	std	<MTestWaitCou
	ldd	#$600
	std	<MotorAcc
	rts

MTestRut:
	ldx	<MTestWaitCou
	inx
	stx	<MTestWaitCou
	cpx	#$70		* Delay tills nsta Speedbyte
	ble	MTrts
	ldx	#0
	stx	<MTestWaitCou

	ldx	<MTestCou1
	ldd	$0,x
	std	<Motor1Speed
	inx
	inx
	cpx	#MTestTabEnd
	bne	MT1NoWrap
	ldx	#MTestTab
MT1NoWrap:
	stx	<MTestCou1

	ldx	<MTestCou2
	ldd	$0,x
	std	<Motor2Speed
	inx
	inx
	cpx	#MTestTab2End
	bne	MT2NoWrap
	ldx	#MTestTab2
MT2NoWrap:
	stx	<MTestCou2

MTrts:	rts

MTestTab:
	fdb	$9000,$7000
MTestTabEnd:
MTestTab2:
	fdb	$7000,$9000
MTestTab2End:

*******************************************************************************
*** Bounce - en ljlig rutin som hjer imponansen p Marvin... 950327
*** Stter tecken 0 och 1 till en studsande boll.

BounceInit:
	ldx	#BounceTab
	stx	<BounceCou
BouRts:	rts

BounceRut:
	ldaa	<Behavior
	anda	#$0f
	cmpa	#$05		* Om Behavior = 5 (Denni) s 
	beq	BouRts		* behvs alla tecken, dvs ingen boll
	ldx	<BounceCou
	ldab	$0,x
	bpl	BounceOk
	ldx	#BounceTab
	ldab	$0,x
BounceOk:
	inx
	stx	<BounceCou
	ldy	#BounceDat
	ldaa	#16		* Justera fel i tabellen...
	sba
	tab
	clra
	aby

	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldab	#%01000000	* Stt GrafikPekare $00
	stab	$04,x		* PortB
	jsr	DisplayWait

	ldab	#$08
	bsr	BounceLop
	iny
	ldab	#$08
	bsr	BounceLop
	bclr	$08,x %00100000	* PD5 - RS
	ldab	#%10000000	* Stt TeckenPekare $00
	stab	$04,x		* PortB
	jmp	DisplayWait

BounceLop:
	ldaa	$00,y
	iny
	bset	$08,x %00100000	* PD5 - RS
	staa	$04,x		* PortB

	pshy
	ldy	#$10
BounceWait:
	dey
	bne	BounceWait
	puly

	decb
	bne	BounceLop
	rts

BounceTab:
	fcb	16,14,13,11,10,9,8,7,7,6,5,5,4,4,3,3,3,2,2,2,2,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0
	fcb	1,1,1,1,1,2,2,2,2,3,3,3,4,4,5,5,6,7,7,8,9,10,11,13,14,$ff

BounceDat:
	fcb	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	fcb	%00100
	fcb	%01110
	fcb	%11111
	fcb	%01110
	fcb	%00100
	fcb	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

*******************************************************************************
*** Displayrutiner
*** Databitar p port B, 8 stycken.
*** En extra styrbit p PD5, RS
*** StrB gr hg automatiskt d vi skriver till PortB - $1004

DisplayInit:
	bset	$02,x %00000001	* PIOC Stt INVB hg = aktiv hg
	bset	$09,x %00100000	* DDRD Stt bit5 portD utgng
	bclr	$02,x %00010000	* PIOC Stt p enkel HNDS
	jsr	DisplayOn
	jsr	Display2rader
	jsr	DisplayClear
	ldx	#DisplayWelcome
	jsr	DisplayToRad1
	bsr	DisplayPutString
	ldx	#DisplayWelcome2
	jsr	DisplayToRad2
	bsr	DisplayPutString
	rts

*** DisplayPutString - skriver ut frn accx till $0. Sparar alla register, utom x.
DisplayPutString:
	psha
DispSLop:
	ldaa	$00,x
	beq	DispEnd
	bsr	DisplayPutChar
	inx
	bra	DispSLop
DispEnd:	pula
	rts

*** DisplayPutChar - skriver ut tecknet i acca till displayen. Sparar alla register.
DisplayPutChar:
	pshx
	ldx	#$1000
	bset	$08,x %00100000	* PD5 - RS=1
	staa	$04,x		* PortB
	pulx
	bra	DisplayWait

*** DisplayHome - flyttar displayen att visa adress noll.
*** Flyttar cursor till adress noll. Sparar alla register.
DisplayHome:
	psha
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldaa	#%00000010	* Home
	staa	$04,x		* PortB
	pulx
	pula
	bra	DisplayWait

*** DisplayOff - stnger av displayen. Sparar alla register.
DisplayOff:
	psha
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldaa	#%00001000	* Off, Cursor On, Cursor blink
	staa	$04,x		* PortB
	pulx
	pula
	bra	DisplayWait

*** DisplayOn - stter p displayen. Sparar alla register.
DisplayOn:
	psha
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldaa	#%00001100	* On, Cursor Off, Cursor blink off
	staa	$04,x		* PortB
	pulx
	pula
	bra	DisplayWait

*** DisplayClear - Tmmer displayen p tecken. Sparar alla register.
DisplayClear:
	psha
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 RS=0
	ldaa	#%00000001	* Clear Display
	staa	$04,x		* PortB
	pulx
	pula
	jmp	DisplayWaitLong

DisplayWait:
	pshy
	ldy	#$10
DispWait2lop:
	dey
	bne	DispWait2lop
	puly
	rts

DisplayWaitLong:
	pshy
	ldy	#$400
DispWait3lop:
	dey
	bne	DispWait3lop
	puly
	rts

***Flyttar cursor till brjan av rad.
DisplayToRad1:
	psha
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldaa	#%10000000	* Home
	staa	$04,x		* PortB
	pulx
	pula
	bra	DisplayWait

DisplayToRad2:
	psha
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldaa	#%11000000	* Home
	staa	$04,x		* PortB
	pulx
	pula
	bra	DisplayWait

DisplayToA:
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	oraa	#%10000000	* Stt adress
	staa	$04,x		* PortB
	pulx
	bra	DisplayWait

Display2rader:
	pshx
	ldx	#$1000
	bclr	$08,x %00100000	* PD5 - RS
	ldaa	#%00111100	* Stt 8bitar, 2 rader, font 2
	staa	$04,x		* PortB
	pulx
	bra	DisplayWait

*** DisplayPutNumber - skriver ut accumulator d till displayen.
*** Sparar alla register

DisplayPutNumber:
	pshx
	psha
	pshb

	pshb
	pshb
	psha

	tab
	lsrb
	lsrb
	lsrb
	lsrb
	ldx	#PutNumTabell
	abx
	ldaa	$0,x
	jsr	DisplayPutChar

	pulb
	andb	#$0f
	ldx	#PutNumTabell
	abx
	ldaa	$0,x
	jsr	DisplayPutChar

	pulb
DisplayPutCont:
	lsrb
	lsrb
	lsrb
	lsrb
	ldx	#PutNumTabell
	abx
	ldaa	$0,x
	jsr	DisplayPutChar

	pulb
	andb	#$0f
	ldx	#PutNumTabell
	abx
	ldaa	$0,x
	jsr	DisplayPutChar

	pulb
	pula
	pulx
	rts

PutNumTabell:
	fcc	'0123456789abcdef'

*** DisplayPutByte - skriver ut 8-bitars hex-talet i accb till displayen. 950328

DisplayPutByte:
	pshx
	psha
	pshb
	pshb
	jmp	DisplayPutCont

*******************************************************************

IrqInit:	ldx	#$1000
	bset	$26,x %00000011	* PACTL - stt real-time interrupt
*	bclr	$26,x %00000001	* rate till 32.77 ms (sid 10-12)

	bclr	$25,x %10111111	* TFLG2 - clear irq-request (sid 10-14)
	bset	$24,x %01000000	* TMSK2 - stt p irq frn RealTime
	ldaa	#%00001010	* Stt IC3 till hgsta prioritet
	staa	$3c,x		* HPRIO (sid 5-14)
	rts

********************************************************************
*** Motorstyrningen fungerar shr:
*** Variablerna MotorXSpeed kan sttas till vilket vrde som helst,
*** nr som helst. MotorRut accelererar Pulsbredden till denna hastighet,
*** med accelerationen MotorAcceleration.
*** MotorXSpeed = $0000 r full back.
*** MotorXSpeed = $8000 r vila.
*** MotorXSpeed = $ffff r full fart framt.
*** MotorRut stter TOC3 och TOC3 fr pulsbredd, samt PA4 och PA3 fr
*** framt/bakt fr motorerna.
*** MotorRut br placeras i en interrupt.

MotorInit:
	ldx	#$1000
	bclr	$24,x %00000011	* TMSK2 stt dividera ner E-klocka 1ggr
	ldaa	#%01100000	* OutputCmp1 ska stta Pa5 Pa6 hg
	staa	$0c,x		* OC1M
	ldaa	#%01100000	* Stt Pa5 Pa6 hg vid rtt OC1-tid
	staa	$0d,x		* OC1D
	bset	$20,x %10100000	* TCTL1 - Oc3 stnger Pa5 (sid 10-31)
	bclr	$20,x %01010000	* Oc2 stnger Pa6
	ldd	#$8000		* Stt OutputCompare1 till tid #$8000
	std	$16,x		* TOC1

	ldd	#$8000		* Stt hastighet noll
	std	<Motor1CurrSpeed
	std	<Motor1Speed
	std	<Motor2CurrSpeed
	std	<Motor2Speed
	ldd	#$8001		* Stt OutputComp.2,3 till #$8001=vila
	std	$18,x		* TOC2
	std	$1a,x		* TOC3

	ldd	#$600
	std	<MotorAcc
	rts

*** MotorRut: Accelererar Motor1 och 2 till deras MotorXSpeed med
*** hastigheten MotorAcceleration. Stter pulsbredden.

MotorRut:
	ldd	<Motor1CurrSpeed
	cpd	<Motor1Speed
	beq	Mot1Change
	blo	Mot1Acc
	subd	<MotorAcc		* Retardera, samt kolla om frdig
	bcs	Mot1Finished	* Wrap $00xx -> $ffxx - stt minSpeed
	cpd	<Motor1Speed
	bhi	Mot1Change
	bra	Mot1Finished
Mot1Acc:
	addd	<MotorAcc		* Accelerera, samt kolla om frdig
	bcs	Mot1Finished	* Wrap $ffxx - $00xx - stt maxSpeed
	cpd	<Motor1Speed
	blo	Mot1Change
Mot1Finished:
	ldd	<Motor1Speed
Mot1Change:
	std	<Motor1CurrSpeed
	ldx	#$1000
	subd	#$8000
	bcc	Mot1Forward
	eora	#$7f
	eorb	#$ff
	bset	$00,x %00010000	* PortA bit4 on = Bakt
	ldy	#$1
	sty	<Motor1Dir
	bra	Mot1SattPuls
Mot1Forward:
	bclr	$00,x %00010000	* PortA bit4 off = Framt
	ldy	#$0
	sty	<Motor1Dir
Mot1SattPuls:
	lsld			* accd * 2
	bne	Mot1NotZero	* Vi fr inte ha speed=0
	ldd	#$1		* Justera speed 0 -> speed 1
Mot1NotZero:
	adda	#$80
	std	$1018		* TOC2
	std	<Motor1Puls
Mot1NoChange:

*** Nu gr vi samma sak med Motor2...

	ldd	<Motor2CurrSpeed
	cpd	<Motor2Speed
	beq	Mot2Change
	blo	Mot2Acc
	subd	<MotorAcc		* Retardera, samt kolla om frdig
	bcs	Mot2Finished	* Wrap $00xx -> $ffxx - stt minSpeed
	cpd	<Motor1Speed
	bhi	Mot2Change
	bra	Mot2Finished
Mot2Acc:
	addd	<MotorAcc		* Accelerera, samt kolla om frdig
	bcs	Mot2Finished	* Wrap $ffxx - $00xx - stt maxSpeed
	cpd	<Motor2Speed
	blo	Mot2Change
Mot2Finished:
	ldd	<Motor2Speed
Mot2Change:
	std	<Motor2CurrSpeed
	ldx	#$1000
	subd	#$8000
	bcc	Mot2Forward
	eora	#$7f
	eorb	#$ff
	bclr	$00,x %00001000	* PortA bit3 off = Bakt
	bra	Mot2SattPuls
Mot2Forward:
	bset	$00,x %00001000	* PortA bit3 on = Framt
Mot2SattPuls:
	lsld			* accd * 2
	bne	Mot2NotZero	* Vi fr inte ha speed=0
	ldd	#$1		* Justera speed 0 -> speed 1
Mot2NotZero:
	adda	#$80
	std	$101a		* TOC3
	std	<Motor2Puls
Mot2NoChange:
	rts

***************************************************
*** Denni - Ett gulligt spel  la Game&Watch...
*** Baserat p spelet "Dare Devil Dennis" p Commodore 64.
*** Nr Denni r aktiverat r BounceRut avstngd, eftersom alla stackars
*** tta egendefinierade tecken fr slita hrt fr att visa grafiken.

DenniInit:
	ldd	#$800
	std	<MotorAcc
	ldd	#$8000
	std	<Motor1Speed
	std	<Motor2Speed

	lda	#$02
	staa	<dod
	jsr	DenniStart
	ldx	#$1000
	bclr	$08,x %00100000
	ldaa	#%00011000	* Shift display left
	staa	$04,x
	jsr	DisplayWait
	bclr	$08,x %00100000
	ldaa	#%00011000	* Shift display left
	staa	$04,x
	jsr	DisplayWait

	ldx	#DenniInitText1
	jsr	DisplayToRad1
	jsr	DisplayPutString
	ldx	#DenniInitText2
	jsr	DisplayToRad2
	jsr	DisplayPutString
	rts

*** DenniExit - terstll displayen, skifta den tv steg till hger, tm den p tecken.

DenniExit:
	ldx	#$1000
	bclr	$08,x %00100000
	ldaa	#%00011100	* Shift display right
	staa	$04,x
	jsr	DisplayWait
	bclr	$08,x %00100000
	ldaa	#%00011100	* Shift display right
	staa	$04,x
	jsr	DisplayWait
	ldx	#DisplayWelcome
	jsr	DisplayToRad1
	jsr	DisplayPutString
	ldx	#DisplayWelcome2
	jsr	DisplayToRad2
	jsr	DisplayPutString
	jsr	InfoDrawAA
	rts

DenniInitText1:
	fcc	'xxDenni ** 9=Start'
	fcb	0
DenniInitText2:
	fcc	'xx'
	fcb	%01111111,%01111111
	fcc	' '
	fcb	%01111110,%01111110
	fcc	' Play=Hopp '

	fcb	0

DenniGameOver1:
	fcc	'xx * GAME OVER! * '
	fcb	0
DenniGameOver2:
	fcc	'xx   Din po'
	fcb	%11100001		* 
	fcc	'ng: '
	fcb	0

DenniGameOver3:
	fcc	'xxTryck 9 f'
	fcb	%11101111		* 
	fcc	'r spel'
	fcb	0
DenniGameOver4:
	fcc	'xx   Din po'
	fcb	%11100001		* 
	fcc	'ng: '
	fcb	0

*** DenniRut - anropas vid varje irq, tar hand om allt som har med spelet att gra.

DenniRut:
	ldaa	<dod
	bne	NoPlay		* Denni r dd - inget mer spel ...
	jsr	ballongrut
	jsr	stolprut
	jsr	bollrut
	jsr	poangrut
	jsr	kollakolli		* Stter dd om hoppa p stolpe.
	rts

NoPlay:	cmpa	#$02		* Vnta, Denni r antingen dd eller vilar
	beq	DenniInitText
	ldx	<IrKomLatch
	cpx	#$e503
	beq	DenniRestart
	inc	<gubbwait		* GameOverRut - Blinka text
	ldaa	<gubbwait
	anda	#$7f
	cmpa	#$30
	beq	DenniGameOverA
	cmpa	#$70
	beq	DenniGameOverB
DeRts:	rts

DenniGameOverA:
	ldx	#DenniGameOver1	* Game over
	jsr	DisplayToRad1
	jsr	DisplayPutString
	ldx	#DenniGameOver2
	jsr	DisplayToRad2
	jsr	DisplayPutString
	rts
DenniGameOverB:
	ldx	#DenniGameOver3	* Tryck fr spel
	jsr	DisplayToRad1
	jsr	DisplayPutString
	ldx	#DenniGameOver4
	jsr	DisplayToRad2
	jsr	DisplayPutString
	rts

DenniInitText:
	ldd	<IrKomLatch	* Vnta tills spelet startas med knappen "9"
	cpd	#$e503
	bne	DeRts
	clr	<dod
	rts

DenniRestart:
	clr	<dod
DenniStart:
	jsr	bollinit
	jsr	markinit
	jsr	ballonginit
	jsr	stolpinit
	jsr	poanginit
	rts

***********************************************************
*** BollRut - tar hand om utritning och frflyttning av gubben

bollinit:	ldd	#$2000
	std	<bollx
	ldd	#$0000
	std	<bollhoppcou
	std	<bollyword
	ldd	#gubb1
	std	<gubbcou
	rts

bollhopp:
	fcb	9,8,7,6,6,5,4,4,3,3,3,2,2,2,2,1,1,1,1,1,0,0,0,0,0,0
	fcb	1,1,1,1,1,2,2,2,2,3,3,3,4,4,5,5,6,7,8,9,$ff

bollrut:
	ldx	#bollbild
clrep:	clr	0,x
	inx
	cpx	#bollbildend
	bne	clrep

	jsr	markrut

	ldy	#$1000

	ldx	<bollhoppcou
	beq	ingehopp
	ldaa	$00,x
	bmi	ingehopp
	inx
	stx	<bollhoppcou
	bra	hopp
ingehopp:
	ldd	#0
	ldx	<IrKomLatch
	cpx	#$ad0a		* Play fr att hoppa
	bne	ingenyhopp
	ldd	#bollhopp
ingenyhopp:
	std	<bollhoppcou
	ldaa	#10
hopp:
	staa	<bolly

	ldd	<bollx
	ldx	<IrKomLatch
	cpx	#$3d18		* FF -knappen
	bne	intehog
	addd	#$0060
intehog:
	cpx	#$bd08		* Rew-knappen
	bne	intevan
	subd	#$0060
intevan:

	cpd	#$5a00
	ble	ejhogervagg
	ldd	#$5a00
ejhogervagg:
	cpd	#$0d00
	bge	ejvanstervagg
	ldd	#$0d00
ejvanstervagg:
	std	<bollx		* accumulator a ar hogbyte

	tab
	clra
	ldx	#$0006
	idiv			* accd ar rest, accx ar heltalsdel

	std	<bollxskift

	xgdx			* exg x,d
	orab	#%10000000	* satt ddram address
	bclr	$08,y %00100000
	ldaa	<bolly
	cmpa	#$8
	bge	ritainteovrerad
	tba
	bsr	bprint
	bset	$08,y %00100000
	ldaa	#00
	bsr	bprint
	ldaa	#02
	bsr	bprint
	bclr	$08,y %00100000
ritainteovrerad:
	addb	#$40
	orab	#$10000000
	ldaa	<bolly
	cmpa	#$2
	ble	bollforts		* rita inte undre rad
	tba
	bsr	bprint
	bset	$08,y %00100000
	ldaa	#01
	bsr	bprint
	ldaa	#03
	bsr	bprint
	bra	bollforts

bprint:	staa	$04,y
	ldaa	#$20
bow:	deca
	bne	bow
	rts

bollforts:
	ldd	#bollbild
	addd	<bollyword
	xgdy

	ldx	<gubbcou
	bsr	skifta
	bsr	skifta
	bsr	skifta
	bsr	skifta
	bsr	skifta
	bsr	skifta
	bsr	skifta
	ldaa	<gubbwait
	suba	#$40
	bcc	nonewgub

	cpx	#gubbend
	blt	ingny
	ldx	#gubb1
ingny:	stx	<gubbcou

nonewgub:
	staa	<gubbwait
	ldy	#$1000
	bclr	$08,y %00100000
	ldaa	#%01000000	* satt cgram-addr
	bsr	bprint
	ldx	#bollbild
	bset	$08,y %00100000
bolo:	ldaa	$00,x
	bsr	bprint
	inx
	cpx	#bollbild+$8
	bne	bonomittstreck
	inx
bonomittstreck:
	cpx	#bollbild+$19
	bne	bonomittstreck2
	inx
bonomittstreck2:
	cpx	#bollbildend
	blt	bolo
	rts

skifta:	ldaa	0,x		* Skifta gubben till rtt x-position
	clrb
	lsrd
	inx
	pshx
	ldx	<bollxskift
	beq	rtss
sklo:	lsrd
	dex
	bne	sklo
rtss:	pulx
	oraa	$00,y
	staa	$00,y
	lsrd
	lsrd
	orab	$11,y
	stab	$11,y
	iny
	rts

gubb1:
	fcb	%0011100		* Den animerade gubben
	fcb	%0111100
	fcb	%0010000
	fcb	%1111100
	fcb	%0111010
	fcb	%1101100
	fcb	%0000110

	fcb	%0011100
	fcb	%0111110
	fcb	%0011000
	fcb	%1111100
	fcb	%0111010
	fcb	%0111000
	fcb	%0001100

	fcb	%0001110
	fcb	%0011110
	fcb	%0001000
	fcb	%0111100
	fcb	%0111100
	fcb	%0111000
	fcb	%0011000

	fcb	%0001110
	fcb	%0011111
	fcb	%0001100
	fcb	%0111000
	fcb	%1111010
	fcb	%0100100
	fcb	%0110000

	fcb	%0011110
	fcb	%0111110
	fcb	%0011000
	fcb	%1111010
	fcb	%1111100
	fcb	%1000111
	fcb	%1100010
gubbend:

************************************************************
*** markrut - animerar marken, dvs rullar den t vnster i lagom takt
*** Lgger ven till mark underst p gubbens tecken och maskarnas tecken.

markinit:
	ldd	#0
	std	<markx
	staa	<markxword
	rts

markrut:
	ldy	#$1000
	bclr	$08,y %00100000
	ldaa	#%01100000	* satt cgram-addr
	bsr	markp
	bset	$08,y %00100000

	ldd	<markx
	addd	#$0040
	cpd	#$0600
	blt	nowrap
	subd	#$0600
nowrap:	std	<markx

	tab
	clra
	xgdx
	ldy	#$1000

	clra
	bsr	markp
	bsr	markp
	bsr	markp
	bsr	markp
	bsr	markp
	ldd	#%0000011000011000
	bsr	markp2
	tab
	staa	<stolpbild1
	oraa	<bollbild+$e
	staa	<bollbild+$e
	staa	<bollbild+$11+$e
	ldd	#%1010111010111010
	bsr	markp2
	staa	<stolpbild2
	oraa	<bollbild+$f
	staa	<bollbild+$f
	staa	<bollbild+$f+$11
	ldaa	#$ff
	bsr	markp
	ldaa	#$ff
	staa	<bollbild+$10
	staa	<bollbild+$10+$11
	rts

markp2:	ldx	<markxword
	beq	markp
marklo:	lsld
	dex
	bne	marklo

markp:	staa	$04,y
	ldab	#$20
nlo:	decb
	bne	nlo
	rts

************************************************************
*** ballongrut - animerar och flyttar ballongerna

ballonger:
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb 0,0
	fcb %01100
	fcb %10110
	fcb %11110
	fcb %01100
	fcb %00100
	fcb %01000

	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb 0,0
	fcb %11000
	fcb %01100
	fcb %11100
	fcb %11000
	fcb %01000
	fcb %01000

	fcb %00000
	fcb %00001
	fcb %00001
	fcb %00000
	fcb %00000
	fcb %00000
	fcb 0,0
	fcb %10000
	fcb %11000
	fcb %11000
	fcb %10000
	fcb %10000
	fcb %10000

	fcb %00001
	fcb %00010
	fcb %00011
	fcb %00001
	fcb %00000
	fcb %00001
	fcb 0,0
	fcb %00000
	fcb %10000
	fcb %10000
	fcb %00000
	fcb %00000
	fcb %00000

	fcb %00011
	fcb %00101
	fcb %00111
	fcb %00011
	fcb %00001
	fcb %00010
	fcb 0,0
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000

	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb %00000
	fcb 0,0
	fcb %00110
	fcb %01011
	fcb %01111
	fcb %00110
	fcb %00010
	fcb %00100
ballongerend:

ballongin:
	fcb	%00101101		* Hur ofta det ska komma ballonger
	fcb	%00001001
	fcb	%00100001
	fcb	%10001101
	fcb	%00101000
	fcb	%01000101
	fcb	%01101100
	fcb	%10000001

ballonginit:
	ldd	#ballonger
	std	<ballongcou
	ldd	#%0000000000000101
	std	<ballonglist
	clr	<ballongcou2
	ldd	#$7000
	std	<ballonghast
	ldaa	#$0b
	staa	<ballongfinx
	clr	<ballongincou
	rts

baprint:
	stab	$04,x
	ldab	#$20
bal:	decb
	bne	bal
	rts

ballongrut:
	ldx	#$1000

	ldd	<ballonghast
	addd	#$0003
	bcc	baok
	ldd	#$ff00
baok:	std	<ballonghast

	addd	<ballongwait
	std	<ballongwait
	bcc	baingenyteck

	bclr	$08,x %00100000
	ldab	#%01101000	* satt cgram-addr
	bsr	baprint
	bset	$08,x %00100000

	clrb
	ldaa	<ballongy
	adda	#$09
	staa	<ballongy
	bmi	overstarad
	bsr	baprint
overstarad:

	ldy	<ballongcou
	ldaa	#$e
baslo:	ldab	0,y
	bsr	baprint
	iny
	deca
	bne	baslo

	dec	<ballongfinx

	cpy	#ballongerend
	blt	banolo

	ldaa	<ballongcou2
	adda	#$80
	staa	<ballongcou2
	bcc	flyttaejba

	ldaa	<ballongincou
	anda	#$3f
	tab
	lsrb
	lsrb
	lsrb
	ldx	#ballongin
	abx
	ldab	0,x
	anda	#$7
	inca
binlo:	lslb			* carry andras inte av deca, ldd
	deca
	bne	binlo

	ldd	<ballonglist
	rolb
	rola
	std	<ballonglist
	ldaa	#$0b
	staa	<ballongfinx
	inc	<ballongincou
	ldx	#$1000
flyttaejba:
	ldy	#ballonger

banolo:	sty	<ballongcou

	clrb
	jsr	baprint
	tst	<ballongy
	bpl	balend
	jsr	baprint
balend:

baingenyteck:
	ldab	#%10000000	* satt ddram address
	bclr	$08,x %00100000
	jsr	baprint
	bset	$08,x %00100000

	ldd	<ballonglist
	ldy	#$a

	tst	<ballongcou2
	beq	barep
	lsld
	bcc	halvnoball
	bra	halvball

barep:	lsld
	bcc	noball
	pshb
	ldab	#05
	jsr	baprint
	pulb
halvball:
	pshb
	ldab	#06
	jsr	baprint
	pulb
	bra	bacont
noball:
	pshb
	ldab	#' 
	jsr	baprint
	pulb
halvnoball:
	pshb
	ldab	#' 
	jsr	baprint
	pulb
bacont:
	dey
	bne	barep
	rts

************************************************************

wait:	pshy
	ldy	#$200
lo:	dey
	bne	lo
	puly
	rts

waitlong:
	pshy
	ldy	#$1000
l2o:	dey
	bne	l2o
	puly
	rts


SkrivUt:
	ldx	#$1000
s_lop:	ldaa	0,y
	beq	slut

	bset	$08,x %00100000	* satt RS pa display
	staa	$04,x

	ldaa	#$20
s_wait:	deca
	bne	s_wait

	iny
	bra	s_lop
slut:	rts

***************************************************************
*** stolprut - animerar maskarna och flyttar dem p displayen

stolpinit:
	ldd	#stolpar
	std	<stolpcou
	ldd	#0
	std	<stolplist
	ldaa	#0
	staa	<stolplist+2
	ldd	#$4000		* $4000
	staa	<stolphast
	clr	<stolpincou
	ldd	#stolpin
	std	<stolpinhighcou
	ldaa	#7
	staa	<stolpfinx
	rts

stolpar:
	fcb %00000		* de animerade maskarna
	fcb %00000
	fcb %00001
	fcb %00001
	fcb %00001
	fcb %00001
	fcb %00011

	fcb %00000
	fcb %00000
	fcb %00011
	fcb %00011
	fcb %00001
	fcb %00001
	fcb %00011

	fcb %00000
	fcb %00110
	fcb %00011
	fcb %00011
	fcb %00011
	fcb %00011
	fcb %00111

	fcb %00000
	fcb %01000
	fcb %01100
	fcb %00110
	fcb %00110
	fcb %00111
	fcb %01111

	fcb %00000
	fcb %01000
	fcb %11100
	fcb %01100
	fcb %01100
	fcb %01100
	fcb %11110

	fcb %00000
	fcb %01100
	fcb %00110
	fcb %01100
	fcb %01100
	fcb %11000
	fcb %11100

	fcb %00000
	fcb %01000
	fcb %01100
	fcb %11100
	fcb %11000
	fcb %11000
	fcb %11100

	fcb %00000
	fcb %00000
	fcb %10000
	fcb %10000
	fcb %10000
	fcb %10000
	fcb %11000
stolparend:

stolpr:	staa	$04,y
	ldaa	#$20
snlo:	deca
	bne	snlo
	rts

stolprut:
	ldd	<stolphast
	addd	#$0007
	bcc	stok
	ldd	#$ff00
stok:	std	<stolphast

	ldy	#$1000

	bclr	$08,y %00100000
	ldaa	#%11000010	* satt ddram address
	bsr	stolpr
	bset	$08,y %00100000
	ldx	#14
	ldd	<stolplist

stolo:	lsrd
	psha
	bcc	barmark
	ldaa	#07
	bra	stcont
barmark:
	ldaa	#04
stcont:	bsr	stolpr
	pula
	dex
	bne	stolo

	bclr	$08,y %00100000
	ldaa	#%01111000	* satt cgram-addr
	bsr	stolpr
	bset	$08,y %00100000

	ldx	<stolpcou
	ldab	#$5
stolo3:	ldaa	0,x
	bsr	stolpr
	inx
	decb
	bne	stolo3
	ldaa	0,x
	oraa	<stolpbild1
	bsr	stolpr
	inx
	ldaa	0,x
	oraa	<stolpbild2
	bsr	stolpr
	inx
	ldaa	#$ff
	bsr	stolpr

	ldd	<stolpwait
	addd	<stolphast
	std	<stolpwait
	bcc	stolpend		* rts

	dec	<stolpfinx

	cpx	#stolparend
	blt	stolpnastanend

	ldaa	#7
	staa	<stolpfinx

	ldy	<stolpinhighcou
	ldaa	<stolpincou
	anda	#$1f
	tab
	lsrb
	lsrb
	lsrb
	aby
	ldab	0,y
	anda	#$7
	inca
stollo:	lslb			* carry andras inte av deca, ldd
	deca
	bne	stollo

	ldaa	<stolplist+2
	rora
	staa	<stolplist+2
	ldd	<stolplist
	rora
	rorb
	std	<stolplist
	inc	<stolpincou
	ldx	#stolpar

stolpnastanend:
	stx	<stolpcou
stolpend:
	rts

stolpin:
	fcb	%00000010	* dessa anvnds nr pong < 20
	fcb	%00001000
	fcb	%01000100
	fcb	%00100000

	fcb	%00010010	* dessa anvnds nr 20 <= pong < 40
	fcb	%00001000
	fcb	%01000100
	fcb	%00100011

	fcb	%00010010	* dessa anvnds nr 40 <= pong < 60
	fcb	%00100000
	fcb	%01001100
	fcb	%00100011

	fcb	%00110010	* dessa anvnds nr pong >= 60
	fcb	%00111000
	fcb	%11000110
	fcb	%01010011
stolpinend:

**************************************************************
*** poangrut - tar hand om pongen.

poanginit:
	ldd	#$3030
	std	<poang
	rts

poangrut:
	ldy	#$1000
	bclr	$08,y %00100000
	ldaa	#%11010000	* satt ddram address
	jsr	stolpr
	bset	$08,y %00100000
	ldaa	<poang
	jsr	stolpr
	ldaa	<poang+1
	jsr	stolpr
	rts

okapoang:
	ldd	<poang
	addb	#1
	cmpb	#$3a
	blt	naj2
	ldab	#$30
	adda	#1
	cmpa	#$3a
	blt	naj
	ldaa	#$30
naj:	psha
	suba	#$30
	anda	#2
	beq	ejokadsvarigh
	pshb
	ldd	<stolpinhighcou
	addd	#4
	cpd	#stolpinend
	bge	ejokad2
	std	<stolpinhighcou
ejokad2:
	pulb
ejokadsvarigh:
	pula
naj2:	std	<poang
	rts

*** kollakolli - rknar efter om Denni har tagit en ballong eller gtt p en mask.
*** Om han tagit ballong fr han ett pong, om han tar en mask r spelet slut.

kollakolli:
	ldaa	<bolly
	cmpa	#03
	bgt	ingenballong

	ldab	<bollx		* $06 = hogerkant
	subb	<ballongfinx
	clra
	ldx	#$c
	idiv			* accd=rest accx=kvot

	cmpb	#$04
	ble	ingenballong

	ldd	#%0100000000000000
	inx
	dex
	beq	fardig
kollarep:
	lsrd
	dex
	bne	kollarep
fardig:
	anda	<ballonglist
	bne	ballongprick
	andb	<ballonglist+1
	beq	ingenballong

ballongprick:
	andb	<ballonglist+1
	coma			* not
	comb			* not
	anda	<ballonglist
	staa	<ballonglist
	andb	<ballonglist+1
	stab	<ballonglist+1
	bsr	okapoang

ingenballong:
	ldaa	<bolly
	cmpa	#03
	ble	ingenstolpe

	ldab	<stolpfinx
	cmpb	#6
	blt	nojust
	subb	#2
nojust:
	ldaa	<bollx		* $06 = hogerkant
	sba			* a=a-b
	suba	#$7
	tab
	clra
	ldx	#$6
	idiv			* accd=rest accx=kvot

	ldy	<stolplist
	cpx	#$10
	blt	stkok
	xgdx
	subd	#$10
	xgdx
	xgdy
	ldab	<stolplist+1
	clra
	xgdy
stkok:
	ldd	#%0000000000000001
	inx
	dex
	beq	fardig2
kollarep2:
	lsld
	dex
	bne	kollarep2
fardig2:
	sty	<kollanu

	anda	<kollanu
	bne	stolpprick
	andb	<kollanu+1
	beq	ingenstolpe

stolpprick:
	ldaa	#$1		* Denni dr
	staa	<dod
	clr	<gubbwait

ingenstolpe:
	rts

*******************************************************************
*** reset - initialiserar stackpekare och annat som MSTE gras hr.

reset:	lds	#$ff		* Initiera stackpointer
	ldx	#$1000
	bclr	$24,x %00000011	* TMSK2 stt dividera ner E-klocka 1ggr
	tpa			* Stt p XIRQ
	anda	#$bf
	tap
	jmp	start
progend:

*** Vektorer som anvnds i HC11:an
*** IC3 anvnds till fjrrkontrollsdekodningen, som grs i mjukvara.
*** Real-Time Interrupt vektor anvnds fr allt annat.
*** Reset, givbetvis, anvnds nr resetknappen aktiveras.

	org	$ffea	* PA0 - IC3 irq
	fdb	IrIrq
	org	$fff0	* Real-Time Interrupt vektor
	fdb	IrqEver
	org	$fffe	* Reset-vektor
	fdb	reset

********************************************************************
*** EEPROM-AREA	$b600-b7ff
	org	$b600

********************************************************************
*** RAM-AREA		$0000-$01ff

	org	$0000

MotorAcc:		rmb	$02
Motor1Speed:		rmb	$02
Motor1CurrSpeed:	rmb	$02
Motor2Speed:		rmb	$02
Motor2CurrSpeed:	rmb	$02

Motor1Dir:		rmb	$02	* Slaskvariabler fr
Motor1Puls:		rmb	$02	* testning av vrden.
Motor2Puls:		rmb	$02	* testning av vrden.

BounceCou:		rmb	$02

MTestCou1:		rmb	$02
MTestCou2:		rmb	$02
MTestWaitCou:		rmb	$02

AnalogCou:	rmb	$01
LdrRight:		rmb	$01
LdrLeft:		rmb	$01
Behavior:	rmb	$01	* Hur Marvin uppfr sig just nu.

IrBusy		rmb	$01
IrValid:		rmb	$01
IrLastTime:	rmb	$02
IrKommando:	rmb	$02
IrKomLatch:	rmb	$02
IrKomLatchOnce:
		rmb	$02
FjarrSpeed:	rmb	$02
BumpWaitCou:	rmb	$01
BumpCou:	rmb	$02

*** DenniVariabler
dod:		rmb	$01
bollhoppcou:	rmb	$02
gubbcou:	rmb	$02	* gubb1
bollx:		rmb	$02	* $2000
bollyword:	rmb	$01	* $00 for att lasa ypos som word
bolly:		rmb	$01
gubbwait:	rmb	$01
bollxskift:	rmb	$02
bollbild:		rmb	$22
bollbildend:

markxword:	rmb	$01
markx:		rmb	$02	* $0000

ballongcou:	rmb	$02	* ballonger
ballongcou2:	rmb	$01
ballongwait:	rmb	$02
ballonglist:	rmb	$02	* var finns det ballonger?
ballongy:	rmb	$01
ballongy2:	rmb	$01
ballonghast:	rmb	$02
ballongfinx:	rmb	$01
ballongincou:	rmb	$01

stolpwait:	rmb	$02
stolpcou:	rmb	$02	* stolpar
stolplist:		rmb	$03

stolpbild1:	rmb	$01
stolpbild2:	rmb	$02
stolphast:	rmb	$02	* $30 - $ff
stolpincou:	rmb	$01
stolpinhighcou:	rmb	$02	* stolpin

stolpfinx:		rmb	$01

poang:		rmb	$02

kollanu:		rmb	$02
*** Slut p DenniVariabler

InfoPoi:		rmb	$02
InfoCou:	rmb	$01

RadarCou:	rmb	$01	* Hll reda p faser
RadarWalls:	rmb	$01	* Var finns det vggar just nu?
RadarSlask:	rmb	$01	* Vad detekterades vid lsning 1?
RadarOn:	rmb	$01	* r radarn p?
RadarLast:	rmb	$01	* Var fanns det vgg senast?
Debug:		rmb	$01
PIDValue:	rmb	$01
	end

